/* assumes IBM TCP/IP 1.2.1 (or possibly higher) for OS/2 1.x and 2.x */

/* to avoid warnings/errors, you will have to fix the TCP/IP headers :
 *
 * in case of TCP/IP 1.2.1:
 * - in netlib.h, remove the useless SIGALRM definition
 * - in utils.h, replace // comments by regular ones 
 * (both headers are not included directly but via types.h) *
 *
 * in case of TCP/IP 2.0:
 * - in types.h, remove the useless SIGALRM definition
 */

#include "ckotcp.h"

#define PIPENAML  _MAX_PATH   /* Max length for named pipe name */

/* Telnet constants */
#define IAC  255
#define AYT  246
#define IP   244

#define TCPIPLIB

#define socket_errno           errno
#define socket_read(f,s,n)     recv(f,s,n,0)
#define socket_write(f,s,n)    send(f,s,n,0)
#define socket_close           soclose
#define socket_ioctl(f,c,b)    ioctl(f,c,(char *)b,sizeof(long))
/* this is a bit dangerous, but we always read a long with sioctl */

_PROTOTYP( void netinit, (void) );
_PROTOTYP( int netcleanup, (void) );

_PROTOTYP( int os2_netopen, (char *, int *, int) );
_PROTOTYP( int os2_netclos, (void) );
_PROTOTYP( int os2_netflui, (void) );
_PROTOTYP( int os2_nettchk, (void) );
_PROTOTYP( int os2_netbreak, (void) );
_PROTOTYP( int os2_netinc, (int) );
_PROTOTYP( int os2_nettol, (char *, int) );
_PROTOTYP( int os2_nettoc, (int) );
